#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <fcntl.h>
#include <unistd.h>
#include <qdos.h>
#include <sys/stat.h>
#include "tar.h"

char _prog_name[] = "tar";
char _copyright[] = "yet another port by jh";
char _version[] = "0.01";
char *  _endmsg = NULL;

long _stack = 8*1024;
long _pipesize = 16*1024;

extern void consetup_title(chanid_t,struct WINDOWDEF *);
void (*_consetup)(chanid_t,struct WINDOWDEF *) = consetup_title;
int (*_cmdwildcard) (char *, char ***, int *) = cmdexpand;

extern char odd[];

struct WINDOWDEF _condetails =
{
    2,
    1,
    0,
    7,
    500,
    220,
    2,
    30
};

static jobid_t chowner(chanid_t chan)
{
    extern char *_sys_var;
    char *scht;
    long *cdb;
    long jid;
    
    scht = *((char **)(_sys_var + 0x78));
    cdb = *(long **)((long *)scht  + (chan & 0xffff));
    jid = *(cdb + 2);
    return jid;
}

extern short qlwait;
extern short qlflag;

void qexit (void)
{
    jobid_t me,you;
    
    if(*odd)
    {
	chdir(odd);
    }
    
    me = getpid();
    you = chowner(getchid(0));
    
    if(me == you)
    {
	if(isatty(0) && isatty(2) && qlwait)
	{
	    char c = 0;
	    fputs("Press a key to exit", stderr);
	    if((io_fbyte(getchid(0), qlwait, &c) == 0) && c == 27)
	    {
		io_fbyte(getchid(0), -1, &c);
	    }
	}
    }
}
typedef struct __dlp__ 
{
    struct __dlp__ *next;
    char *dln;
    size_t dll;
} DLP;

char *cvtUNIX2SMS(char *name)
{
    char *p;
    for(p = name; *p; p++)
    {
	if(*p == '/' || *p == '.') *p = '_';
    }
    return name;
}

void SetHeader(char *p, union record *h)
{
    int fd;

    strcpy(h->header.magic_cookie, "SMSQDOSTar");    
    fd = open(p, O_RDONLY); /* use c i/o to use def dir */
    if (fd >  0)
    {
	struct qdirect s;
	fs_headr(getchid(fd), -1, (char *)&s, (int) sizeof(s));	    
	close(fd);
	h->header.d_length = s.d_length;
	h->header.d_access = s.d_access;
	h->header.d_type = s.d_type;
	h->header.d_datalen = s.d_datalen;
	h->header.d_reserved = s.d_reserved;
    }
}        

void SetSMSStuff(int fd, union record *h)
{
    if((strcmp(h->header.magic_cookie, "SMSQDOSTar") == 0) && h->header.d_type)
    {
	int ch = getchid(fd);
	fs_heads(ch, (timeout_t)-1, &h->header.d_length, 14);
    }
}
static DLP *AddDent(char *s, DLP *dlp, int n)
{
    DLP *d;
    d = malloc(sizeof(DLP));
    d->dln = strdup(s);
    d->dll = strlen(s);
    d->next = dlp;
    dlp = d;
    if(n)
    {
	s[n] = '/';
    }
    return dlp;
}

char *cvtSMS2UNIX(char *name, char *newname)
{
    char wd[36];
    char *p;
    char *s;
    int n;
    static DLP *dlp = NULL;
    
    getcwd(wd, sizeof(wd));
    if(strstr(name, wd))
    {
	s = name + strlen(wd);
    }
    else
    {
	s = name;
    }
    
    n = strlen(s);

    if(n == 0)
    {
	strcpy(newname, "./");
    }
    else
    {
	s = strcpy(newname, s);
	if(s[n-1] == '_')
	{
	    dlp = AddDent(s, dlp, n-1);
	}
	else 
	{
	    char *q;
	    int j;	    

	    /* First check for hidden dirs */

	    if(dlp == NULL)
	    {		
		char *r;
		int sts;
		struct stat st;
		
		for(r = s; *r; r++)
		{
		    if(*r == '_')
		    {
			*r = 0;
			sts = stat(s, &st);
			*r = '_';
			
			if(sts ==0 && (st.st_mode & S_IFDIR))
			{
			    char cc = *(r+1);
			    *(r+1) = 0;
			    dlp = AddDent(s, dlp, 0);
			    *(r+1) = cc;
			}
		    }
		}
	    }
	    
	    while(dlp)
	    {
		if(strncmp(s, dlp->dln, dlp->dll) == 0) /* matches this */
		{
		    for(j = 0; j < dlp->dll; j++)
		    {
			if(s[j] == '_') s[j] = '/';
		    }
		    break;
		}
		else
		{
		    DLP *z;
		    {
			z = dlp;
			dlp = dlp->next;
			free(z->dln);
			free(z);
		    }
		}
	    }	    
	    if((q = strrchr(s+j, '_')))
	    {
		*q = '.';
	    }
	}
    }
    return newname;
}
